## radium-compressor 0.5.1

=== Makefile ===
PREFIX ?= /usr/local
bindir ?= $(PREFIX)/bin
libdir ?= $(PREFIX)/lib


# These two commands are used by me, since most of the source files are stored in the Radium tree.
# You would normally just run "make" to compile the program.
#
# make copy_files && make all && ./radium_compressor 
# make copy_files && rm -f benchmark && make benchmark && ./benchmark && ./benchmark && ./benchmark


CPP = g++ -DDEBUG -O3 -Wall -msse -mfpmath=sse -DUSE_QT_REQTYPE -DUSE_QT4 -g -I. -ffast-math -IQt

#FAUST = /home/kjetil/faudiostream/compiler/faust -vec
FAUST = faust -vec

# only used for copy files
RADIUM_PATH = /home/kjetil/radium-qt4

all: audio/system_compressor.cpp
	cd Qt && ./create_source_from_ui.sh `../find_moc_and_uic_paths.sh uic` `../find_moc_and_uic_paths.sh moc` compressor_widget
	$(CPP) Qt/Qt_SliderPainter.cpp `pkg-config --cflags Qt3Support` -c
	$(CPP) main.cpp Qt_SliderPainter.o -Iaudio/faudiostream/architecture/ `pkg-config --libs --cflags Qt3Support` -ljack -o radium_compressor


install:
	install -d $(DESTDIR)$(bindir)
	cp radium_compressor $(DESTDIR)$(bindir)/


uninstall:
	rm -f $(DESTDIR)$(bindir)/radium_compressor


copy_files:
	cp $(RADIUM_PATH)/Qt/qt4_compressor_widget.ui Qt/
	cp $(RADIUM_PATH)/Qt/Qt_compressor_widget_callbacks.h Qt/
	cp $(RADIUM_PATH)/Qt/Qt_MyQCheckBox.h Qt/
	cp $(RADIUM_PATH)/Qt/Qt_MyQButton.h Qt/
	cp $(RADIUM_PATH)/Qt/Qt_MyQSlider.* Qt/
	cp $(RADIUM_PATH)/Qt/Qt_SliderPainter* Qt/
	cp $(RADIUM_PATH)/Qt/create_source_from_ui.sh Qt/
	cp $(RADIUM_PATH)/Qt/EditorWidget.h Qt/
	cp $(RADIUM_PATH)/Qt/OS_Visual.h Qt/
	cp $(RADIUM_PATH)/Qt/Qt_ReqType.h Qt/
	cp $(RADIUM_PATH)/Qt/Qt_instruments_proc.h Qt/

	cp $(RADIUM_PATH)/audio/system_compressor.dsp audio/
	cp $(RADIUM_PATH)/audio/typepunning.h audio/
	cp $(RADIUM_PATH)/audio/undo_audio_effect_proc.h audio/
	cp $(RADIUM_PATH)/audio/SoundPlugin.h audio/
	cp $(RADIUM_PATH)/audio/SoundPlugin_proc.h audio/
	cp $(RADIUM_PATH)/audio/Smooth_proc.h audio/

	cp $(RADIUM_PATH)/common/nsmtracker.h common/
	cp $(RADIUM_PATH)/common/debug_proc.h common/
	cp $(RADIUM_PATH)/common/memory_proc.h common/
	cp $(RADIUM_PATH)/common/nsmtracker_events.h common/
	cp $(RADIUM_PATH)/common/keyboard_sub_ids.h common/
	cp $(RADIUM_PATH)/common/OS_error_proc.h common/
	cp $(RADIUM_PATH)/common/OS_Semaphores.h common/
	cp $(RADIUM_PATH)/common/mouse.h common/
	cp $(RADIUM_PATH)/common/windows_proc.h common/
	cp $(RADIUM_PATH)/common/visual_proc.h common/
	cp $(RADIUM_PATH)/common/OS_visual_input.h common/
	cp $(RADIUM_PATH)/common/visual_op_queue_proc.h common/
	cp $(RADIUM_PATH)/common/undo_patchvoice_proc.h common/
	cp $(RADIUM_PATH)/common/instruments_proc.h common/
	cp $(RADIUM_PATH)/common/vector_proc.h common/
	cp $(RADIUM_PATH)/common/settings_proc.h common/
	cp $(RADIUM_PATH)/common/hashmap_proc.h common/

	cp $(RADIUM_PATH)/find_moc_and_uic_paths.sh .
	cp -a $(RADIUM_PATH)/audio/faudiostream audio/


audio/system_compressor.cpp: audio/system_compressor.dsp
	$(FAUST) audio/system_compressor.dsp >audio/system_compressor.cpp

# Note that 0.9.55 runs the benchmark program a bit faster than 0.9.46.
# I guess it's because of more min/max functions in 0.9.55, but it could also
# be because of some castings.
benchmark:
	$(FAUST) -a bench.cpp audio/system_compressor.dsp >compressor_benchmark.cpp 
	$(CPP) benchmark.cpp -Iaudio -o benchmark -lpthread

# original db2linear/linear2db: 60 MB/s
# fast pow2/log: 420 MB/s
# faster pow2/log: 530 MB/s
# lookup table: 420 MB/s
# no db<->linear conversion: 610 MB/s

# Relative accuracy of faster pow2 / faster log: 0.0152579 / 0.0130367
# Relative accuracy of fast pow2 / fast log: 1.58868e-05 / 2.09348e-05

=== debian/changelog ===
radium-compressor (0.5.1-3build2) bionic; urgency=high

  * No change rebuild to pick up -fPIE compiler default

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 03 Apr 2018 12:41:14 +0000

radium-compressor (0.5.1-3build1) wily; urgency=medium

  * No-change rebuild against libjack-jackd2-0v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 11 Aug 2015 07:04:40 +0000

radium-compressor (0.5.1-3) unstable; urgency=low

  * Team upload.
  * debian/patches/0003-gcc4.6-designated-initializers.patch: Fix build with
    gcc 4.6. Thanks to Andrey Rahmatullin for the analysis. (Closes: #709228)

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 24 May 2013 14:39:33 +0200

radium-compressor (0.5.1-2) unstable; urgency=low

  * Fix missing #include <stdlib.h>.

 -- Alessio Treglia <alessio@debian.org>  Sat, 06 Apr 2013 19:23:44 +0100

radium-compressor (0.5.1-1) unstable; urgency=low

  * Initial release. (Closes: #699606)

 -- Alessio Treglia <alessio@debian.org>  Sat, 02 Feb 2013 12:02:58 +0000

=== debian/control ===
Source: radium-compressor
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>
Build-Depends:
 debhelper (>= 9~),
 libjack-dev,
 libqt4-dev,
 qt4-dev-tools
Standards-Version: 3.9.4
Homepage: https://github.com/kmatheussen/radium_compressor
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/radium-compressor.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/radium-compressor.git

Package: radium-compressor
Architecture: any
Depends:
 jackd,
 ${misc:Depends},
 ${shlibs:Depends}
Description: audio compressor for JACK
 Radium Compressor is the system compressor in Radium,
 but distributed as a standalone JACK client application.
 .
 Radium Compressor uses the stereo compressor found in
 effect.lib in the Faust distribution.

## radium-compressor 0.5.1+git20190909

=== Makefile ===
--- 
+++ 
@@ -2,6 +2,8 @@
 bindir ?= $(PREFIX)/bin
 libdir ?= $(PREFIX)/lib
 
+#FIX locally. Line below removed from dsp file.
+#effect.bypass2(checkbox("[6] bypass"), compressor) 
 
 # These two commands are used by me, since most of the source files are stored in the Radium tree.
 # You would normally just run "make" to compile the program.
@@ -9,8 +11,14 @@
 # make copy_files && make all && ./radium_compressor 
 # make copy_files && rm -f benchmark && make benchmark && ./benchmark && ./benchmark && ./benchmark
 
+OPT = -O3 -ffast-math
+OPT_DSP = -O3 -ffast-math -Wno-strict-aliasing
+#-funroll-loops
+CPP = g++ -DDEBUG  -Wall -msse -mfpmath=sse -DUSE_QT_REQTYPE -DUSE_QT4 -g -I. -IQt -fPIC -Wno-class-memaccess
+#  -fpredictive-commoning -ftree-vectorize 
+# -funroll-loops -fira-loop-pressure -fipa-cp-clone -ftree-loop-distribute-patterns
 
-CPP = g++ -DDEBUG -O3 -Wall -msse -mfpmath=sse -DUSE_QT_REQTYPE -DUSE_QT4 -g -I. -ffast-math -IQt
+#-finline-functions 
 
 #FAUST = /home/kjetil/faudiostream/compiler/faust -vec
 FAUST = faust -vec
@@ -18,11 +26,15 @@
 # only used for copy files
 RADIUM_PATH = /home/kjetil/radium-qt4
 
-all: audio/system_compressor.cpp
+all: system_compressor_wrapper.o myladspa.o
 	cd Qt && ./create_source_from_ui.sh `../find_moc_and_uic_paths.sh uic` `../find_moc_and_uic_paths.sh moc` compressor_widget
-	$(CPP) Qt/Qt_SliderPainter.cpp `pkg-config --cflags Qt3Support` -c
-	$(CPP) main.cpp Qt_SliderPainter.o -Iaudio/faudiostream/architecture/ `pkg-config --libs --cflags Qt3Support` -ljack -o radium_compressor
+	$(CPP) Qt/Qt_SliderPainter.cpp `pkg-config --cflags Qt5Widgets` -c  $(OPT)
+	$(CPP) main.cpp Qt_SliderPainter.o system_compressor_wrapper.o myladspa.o -DCOMPILING_STANDALONE -Iaudio/faudiostream/architecture/ `pkg-config --cflags Qt5Widgets --libs Qt5Core --libs Qt5Widgets` `pkg-config --cflags --libs liblo`  -ljack -o radium_compressor  $(OPT)
+# /usr/lib64/libprofiler.so.0
+# make copy_files && make all && CPUPROFILE=ls.prof ./radium_compressor 
 
+clean:
+	rm -f *.o
 
 install:
 	install -d $(DESTDIR)$(bindir)
@@ -32,9 +44,33 @@
 uninstall:
 	rm -f $(DESTDIR)$(bindir)/radium_compressor
 
+# ladpa plugin
+radium_compressor.so: audio/system_compressor.cpp myladspa.o system_compressor_wrapper_ladspa.o
+	$(CPP) Qt/Qt_SliderPainter.cpp `pkg-config --cflags Qt5Widgets` -c -fPIC $(OPT)
+	$(CPP) -DCOMPILING_LADSPA main.cpp -Iaudio/faudiostream/architecture/ `pkg-config --libs --cflags Qt5Widgets` -c -fPIC  $(OPT)
+	$(CPP) `pkg-config --libs Qt5Widgets` myladspa.o system_compressor_wrapper_ladspa.o -shared -fPIC -o radium_compressor.so
+
+system_compressor_wrapper.o: audio/system_compressor_wrapper.cpp audio/system_compressor.cpp
+	$(CPP) -Ifaudiostream/architecture `pkg-config --cflags Qt5Core` -DCOMPILING_STANDALONE audio/system_compressor_wrapper.cpp -c -fPIC $(OPT_DSP)
+
+system_compressor_wrapper_ladspa.o: audio/system_compressor_wrapper.cpp audio/system_compressor.cpp
+	$(CPP) -Ifaudiostream/architecture `pkg-config --cflags Qt5Core` -DCOMPILING_LADSPA audio/system_compressor_wrapper.cpp -c -fPIC -o system_compressor_wrapper_ladspa.o $(OPT_DSP)
+
+myladspa.o: myladspa.cpp audio/system_compressor.cpp
+	$(CPP) -DCOMPILING_LADSPA -Ifaudiostream/architecture `pkg-config --cflags Qt5Core` myladspa.cpp -fPIC -c  $(OPT_DSP)
+
+audio/system_compressor.cpp: audio/system_compressor.dsp standalone_compressor.dsp
+	cp standalone_compressor.dsp audio/
+	$(FAUST) -cn Faust_system_compressor audio/standalone_compressor.dsp >audio/system_compressor.cpp
+
+#audio/system_compressor_ladspa.cpp: audio/system_compressor.dsp standalone_compressor.dsp
+#	cp standalone_compressor.dsp audio/
+#	$(FAUST) -cn Faust_system_compressor -a myladspa.cpp audio/standalone_compressor.dsp >audio/system_compressor_ladspa.cpp
+
 
 copy_files:
 	cp $(RADIUM_PATH)/Qt/qt4_compressor_widget.ui Qt/
+	cp $(RADIUM_PATH)/Qt/compressor_vertical_sliders.cpp Qt/
 	cp $(RADIUM_PATH)/Qt/Qt_compressor_widget_callbacks.h Qt/
 	cp $(RADIUM_PATH)/Qt/Qt_MyQCheckBox.h Qt/
 	cp $(RADIUM_PATH)/Qt/Qt_MyQButton.h Qt/
@@ -47,6 +83,9 @@
 	cp $(RADIUM_PATH)/Qt/Qt_instruments_proc.h Qt/
 
 	cp $(RADIUM_PATH)/audio/system_compressor.dsp audio/
+	cp $(RADIUM_PATH)/audio/fast_log_exp.dsp audio/
+	cp $(RADIUM_PATH)/audio/system_compressor_wrapper_proc.h audio/
+	cp $(RADIUM_PATH)/audio/system_compressor_wrapper.cpp audio/
 	cp $(RADIUM_PATH)/audio/typepunning.h audio/
 	cp $(RADIUM_PATH)/audio/undo_audio_effect_proc.h audio/
 	cp $(RADIUM_PATH)/audio/SoundPlugin.h audio/
@@ -75,15 +114,12 @@
 	cp -a $(RADIUM_PATH)/audio/faudiostream audio/
 
 
-audio/system_compressor.cpp: audio/system_compressor.dsp
-	$(FAUST) audio/system_compressor.dsp >audio/system_compressor.cpp
-
 # Note that 0.9.55 runs the benchmark program a bit faster than 0.9.46.
 # I guess it's because of more min/max functions in 0.9.55, but it could also
 # be because of some castings.
 benchmark:
 	$(FAUST) -a bench.cpp audio/system_compressor.dsp >compressor_benchmark.cpp 
-	$(CPP) benchmark.cpp -Iaudio -o benchmark -lpthread
+	$(CPP) benchmark.cpp -Iaudio -o benchmark -lpthread $(OPT_DSP)
 
 # original db2linear/linear2db: 60 MB/s
 # fast pow2/log: 420 MB/s
@@ -94,3 +130,13 @@
 # Relative accuracy of faster pow2 / faster log: 0.0152579 / 0.0130367
 # Relative accuracy of fast pow2 / fast log: 1.58868e-05 / 2.09348e-05
 
+#/home/kjetil/faudiostream/compiler/faust -a ladspa.cpp system_compressor.dsp >ladspa_compressor.cpp
+#g++ ladspa_compressor.cpp -I /home/kjetil/faudiostream/architecture/ -shared -fPIC -o ladspa_compressor.so
+
+VSTPATH = /home/kjetil/Dropbox/radium_build/vstsdk2.4
+vst:
+	$(FAUST) audio/standalone_compressor.dsp >compressor_vst.cpp
+	$(CPP) Qt/Qt_SliderPainter.cpp `pkg-config --cflags Qt5Widgets` -c -fPIC
+	$(CPP) -DCOMPILING_VST main.cpp -Iaudio/faudiostream/architecture/ `pkg-config --libs --cflags Qt5Widgets` -c -fPIC
+	$(CPP) -I $(VSTPATH)/public.sdk/source/vst2.x/ -I $(VSTPATH)/pluginterfaces/vst2.x/ -I $(VSTPATH) `pkg-config --cflags Qt5Widgets` `pkg-config --libs Qt5Widgets` vstplugin.cpp -Iaudio $(VSTPATH)/public.sdk/source/vst2.x/audioeffectx.cpp $(VSTPATH)/public.sdk/source/vst2.x/audioeffect.cpp  $(VSTPATH)/public.sdk/source/vst2.x/vstplugmain.cpp main.o Qt_SliderPainter.o -shared -o radium_compressor.so -fPIC
+

=== debian/changelog ===
radium-compressor (0.5.1+git20190909-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:33:08 +1100

radium-compressor (0.5.1+git20190909-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:59:32 +0000

radium-compressor (0.5.1+git20190909-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:24:52 +0100

radium-compressor (0.5.1+git20190909-1) unstable; urgency=medium

  * Team upload.

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/control: Set Vcs-* to salsa.debian.org

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat

  [ Sebastian Ramacher ]
  * New upstream snapshot
    - Switch to Qt 5 (Closes: #875168)
  * debian/: Bump debhelper compat to 12
  * debian/control:
    - Bump Standards-Version
    - Add B-Ds on ladspa-sdk and liblo-dev

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 15 Sep 2019 21:16:38 +0200

=== debian/control ===
Source: radium-compressor
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 ladspa-sdk,
 libjack-dev,
 liblo-dev,
 qtbase5-dev,
 qttools5-dev-tools
Standards-Version: 4.4.0
Homepage: https://github.com/kmatheussen/radium_compressor
Vcs-Git: https://salsa.debian.org/multimedia-team/radium-compressor.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/radium-compressor

Package: radium-compressor
Architecture: any
Depends:
 jackd,
 ${misc:Depends},
 ${shlibs:Depends}
Description: audio compressor for JACK
 Radium Compressor is the system compressor in Radium,
 but distributed as a standalone JACK client application.
 .
 Radium Compressor uses the stereo compressor found in
 effect.lib in the Faust distribution.

=== debian/rules ===
#!/usr/bin/make -f

ifeq (amd64,$(DEB_BUILD_ARCH))
CXXFLAGS += -msse -mfpmath=sse
endif

LDFLAGS += -Wl,--as-needed

export QT_SELECT=5
export PREFIX=/usr
export DESTDIR=debian/radium-compressor

%:
	dh $@

=== debian/watch ===
version=3
http://archive.notam02.no/arkiv/src/radium_compressor-(.*)\.tar\.gz
